/******************************************************************************
 * File/main.hpp = Kopf der C++-Datei "main.cpp" und deren Beschreibungen.    *
 * ========================================================================== *
 * Copyright by Hilfe & Service von EDV-Fachleuten      INet www.husvedvf.de  *
 *              Inhaber Harald Schrfer                 Tel. (0345) 521 13 40 *
 *              Reilstr. 22                             Funk (0177) 521 13 40 *
 *                                                      EM   hsc@husvedvf.de  *
 *              D-06114 Halle (Saale)                   Fax  (0345) 521 13 41 *
 * -------------------------------------------------------------------------- *
 * Edit see funktion header!                                                  *
 ******************************************************************************/

/******* Include files ********************************************************/
#include <stdio.h>   // FILENAME_MAX
// #include <conio.h>   // getch()
#include <cstring>   // strncpy, ...
#include <cstdlib>
#include <dirent.h>   // DIR, dirent, FileList.CBP
// #include <C:\Program Files (x86)\CodeBlocks\MinGW\x86_64-w64-mingw32\include\fileapi.h>
// #include <filesystem>
// io.h   // remove & rename
#include <iostream>   // remove(),  rename()
#include <fstream>
#include <string>
#include <windows.h>   // MAX_PATH, FileList.CBP

#include <sys/types.h>   // Typen von Dateien und deren Kennzeichen
#include <sys/stat.h>   // struct stat, stat() + int  stat(char *dateiname, struct stat *puffer);

using namespace std;


/******* Constant definieren
typedef struct _WIN32_FIND_DATAA {
 DWORD dwFileAttributes;
 FILETIME ftCreationTime;
 FILETIME ftLastAccessTime;
 FILETIME ftLastWriteTime;
 DWORD nFileSizeHigh;
 DWORD nFileSizeLow;
 DWORD dwOID;
 TCHAR cFileName[MAX_PATH];
 } _WIN32_FIND_DATAA;
 **************************************************/

/******* Definition from constant *********************************************/
#ifndef MAIN_HPP
 #define MAIN_HPP

 typedef struct ELEMENTINFO {
  DWORD dwFileAttributes;
  FILETIME ftCreationTime;
  FILETIME ftLastAccessTime;
  FILETIME ftLastWriteTime;
  DWORD nFileSizeHigh;
  DWORD nFileSizeLow;
  DWORD dwOID;
  TCHAR cFileName[MAX_PATH];
  } sEleInfo, *pEleInfo;

 /****** Declaration form variable ********************************************/
 short int unsigned gwFehler;   // Speicher fuer die vom Programmierer definierten Fehler.

 #endif // MAIN_HPP


/******* Forward declaration of function **************************************/


/******************************************************************************
 * fc4bak = File FOR BAKup                                                    *
 * Als Parameter uebergebene Information ueber                                *
 * - Laufwerk+Verzeichnisse und                                               *
 * - Dateiname.Typ                                                            *
 * soll am gleiche Ort des Pfades = Laufwerk+Verzeichnisse die Endung         *
 * der Datei in BAK umbeannt werden.                                          *
 * Hilfreich, wenn ein Programm eine Datei (tee.exe /n) NEU erstellen will,   *
 * um vorher von dem bisherigen Inhalt ein Backup davon zu haben.             *
 * Syntax:                                                                    *
 * EXIST_SUCCESS = fc4bak(C:\\Source\\CPP\\Lektion\\01Basic\\File\\Tmp",      *
 *                        "LogBuch.TXT");                                     *
 * -------------------------------------------------------------------------- *
 * Edit v1.000 from 2023-12-29 to 2024-01-17 by HSc                           *
 ******************************************************************************/
int l2bak(
 string strPfad,   // Pfad wo sich die Datei befinden sollte.
 string strDatei   // Name.Typ der Datei die in Name.BAK umbenannt werden soll.
 );   // EXIT_SUCCESS


/******************************************************************************
 * FLile _ LIST                                                               *
 * Auflisten von Dateien und deren Eigenschaften im vorgegebenen Verzeichns.  *
 * Syntax:                                                                    *
 * 0 = fl_list("C:\\Source\\CPP\\Lektion\\01Basic\\File\\Tmp");               *
 * -------------------------------------------------------------------------- *
 * Edit v1.010 form 2023-05-19 to 2024-01-18 by Harald Schaerfer              *
 ******************************************************************************/
int fl_list(
 string strPfad   // Laufwerk:\Verzeichnis des Ortes der Datei.
 );   // Anzahl der Dateien.


/******************************************************************************
 * FiLe _ WRITE                                                               *
 * OEffnens einer Datei "strDatei" am vorgegebenen Pfad "strPfad" um etwas    *
 * hinein schreiben.                                                          *
 * Vorlauefer eines Logbuches "strLogBuch" das als Datei geoeffnet wird und   *
 * das Geschehen protokollieren soll.                                         *
 * Syntax:                                                                    *
 * 0 = fl_write("C:\\Source\\CPP\\Lektion\\01Basic\\File\\Tmp",               *
 *              "LogBuch.TXT");                                               *
 * -------------------------------------------------------------------------- *
 * Edit v1.004 form 2023-05-25 to 2024-01-03 by Harald Schaerfer              *
 ******************************************************************************/
int fl_write(
 string strPfad,   // Laufwerk:\Verzeichnis des Ortes der Datei.
 string strDatei   // Name.Typ der Datei.
 );   // Anzahl der geschrieben Bytes.


/******************************************************************************
 * f2bak = File ZU BAKup                                                      *
 * Als Parameter uebergebene Information ueber                                *
 * - Laufwerk+Verzeichnisse und                                               *
 * - Dateiname.Typ der originalen Datei als Quelle                            *
 * soll am gleiche Ort des Pfades = Laufwerk+Verzeichnisse der Typ der Datei  *
 * in BAK wie Backup umbeannt werden.                                         *
 * Bei der Existenz einer Datei mit der Endung BAK, wird diese vorab          *
 * geloescht!                                                                 *
 * Syntax:                                                                    *
 * 0 = fren2bak("C:\\Source\\CPP\\Lektion\\01Basic\\File\\Tmp",               *
 *              "LogBuch.TXT");                                               *
 * -------------------------------------------------------------------------- *
 * Edit v0.051 from 2023-12-29 to 2024-01-17 by HSc                           *
 ******************************************************************************/
int fl2bak(
 string strPfad,   // Laufwerk:\Verzeichnis des Ortes der Datei.
 string strDatei   // Name.Typ der originalen Datei.
 );   // EXIT_SUCCESS/EXIT_FAILURE bei erfolgreicher/nicht erfolgreicher Funktionalitaet.


/******************************************************************************
 * main = Kopf der Hauptdatei und deren Beschreibungen.                       *
 * -------------------------------------------------------------------------- *
 * Edit v0.030 from 2020-10-28 to 2023-12-29 by HSc                           *
 ******************************************************************************/
int main (
 int iArg,   // Anzahl der uebergebenen Argumente, wobei Nr. 0 der Programm-Name mit Pfad und Laufwerk ist.
 char* pcaArg[],   // Feld mit Zeigern auf die uebergebenen Argumenten.
 char* pcaEnv[]   // Feld mit Zeigern auf die Umgebungsvariablen und ihren Werten.
 );   // giFehler mit der Nummer des (Integer) oder des (8 Bits) Fehlers.
/******* EOF ******************************************************************/
